% ..  .
%   MATLAB. 2023
%Script 1.4
%     
clc; clear all; close all
%  
% 
U0=[1 .5];
% 
t0=[0 .5];
%     
tmin=-2.5;
tmax=2;
% 
dt=.001;
%  
t=tmin:dt:tmax;
% ""
a=2;
%   
exp_puls=@(t) exp(-a*t).*(t>=0);
gaus_puls=@(t)exp(-(a*t).^2);
%  
str_color=(['b','g']);
%  
nU0=length(U0);
nt=length(t);
u1=zeros(nU0,nt);
u2=zeros(nU0,nt);
str_leg=cell(nU0,1);
% 
for k=1:nU0;
str_leg{k}=['U_0 = ',num2str(U0(k)),' , t_0 = ',num2str(t0(k)),' '];
u1(k,:)=U0(k)*exp_puls(t-t0(k));
u2(k,:)=U0(k)*gaus_puls(t-t0(k));
end
%   
du=.1;
subplot(2,1,1)
plot(t,u1)
xlim([tmin tmax])
umin=-du;
umax=max(U0)+du;
ylim([umin umax])
grid
xlabel('t, ')
ylabel('u_1(t), u_2(t), ')
legend(str_leg,'Location','NorthWest')
title([' , \alpha = ',num2str(a),' ^{-1}'])
%  
for k=1:nU0
line([t0(k) 1/a+t0(k)],[U0(k) 0],'LineStyle','--','Color',str_color(k)) 
end
%   
subplot(2,1,2)
plot(t,u2)
xlim([tmin tmax])
umin=-du;
umax=max(U0)+du;
ylim([umin umax])
grid
xlabel('t, ')
ylabel('u_1(t), u_2(t), ')
legend(str_leg,'Location','NorthWest')
title([' , \alpha = ',num2str(a),' ^{-1}'])
%  
x0=1/sqrt(2)/a;
y0=1/sqrt(exp(1));
for k=1:nU0
line([-x0+t0(k) -x0+t0(k)],[0 U0(k)*y0],'LineStyle','--','Color',str_color(k)) 
line([-x0+t0(k) x0+t0(k)],[U0(k)*y0 U0(k)*y0],'LineStyle','--','Color',str_color(k)) 
line([x0+t0(k) x0+t0(k)],[0 U0(k)*y0],'LineStyle','--','Color',str_color(k)) 
end
%  
Ee=integral(@(t)exp_puls(t).^2,0,inf);
Eg=integral(@(t)gaus_puls(t).^2,-inf,inf);
%   
disp(' :')
disp('--------------------------')
for k=1:length(U0)
fprintf('%u- :\n',k)
E1=U0(k)^2*Ee;
E2=U0(k)^2*.5/a;
fprintf('- () %f ;\n',E1)
fprintf('- () %f .\n',E2)
end
disp(' ')
disp(' :')
disp('--------------------------')
for k=1:length(U0)
fprintf('%u- :\n',k)
E1=U0(k)^2*Eg;
E2=U0(k)^2*sqrt(pi/2)/a;
fprintf('- () %f ;\n',E1)
fprintf('- () %f .\n',E2)
end