% ..  .
%   MATLAB. 2023
%Script 1.5
%   
clc; clear all; close all
%  
% 
U0=1;
% 
T=1;
%     
tmin=-.1*T;
tmax=1.1*T;
% 
vf0=[2/T 5.5/T 10.1/T 15.1/T];
nf0=length(vf0);
%     
kf=100;
%  
E1=zeros(nf0);
E2=zeros(nf0);
f0_T=zeros(nf0);
PF1=zeros(nf0);
PF2=zeros(nf0);
%    
for k=1:nf0
% 
f0=vf0(k);
% 
fs=kf*f0;
% 
dt=1/fs;
%  
t=tmin:dt:tmax;
%  
w0=2*pi*f0;
%  
a=U0*rectpuls(t-T/2,T);
% 
u=a.*cos(w0*t);
%  
subplot(nf0/2,2,k)
plot(t,u)
hold on
plot(t,a,'--r')
xlim([tmin tmax])
ylim([-U0-.1 U0+.1])
grid
%   - 
f0_T(k)=f0*T;
E1(k)=integral(@(t)(U0*cos(w0*t)).^2,0,T);
E2(k)=U0^2*T/2+U0^2*T/2*sin(2*w0*T)/(2*w0*T);
PF1(k)=U0^2/(E1(k)/T);
PF2(k)=U0^2/(E2(k)/T);
title(['f_0T = ',num2str(f0*T)])
xlabel('t, ')
ylabel('u(t), ')
end 
%  
disp(' :')
disp('..       ')
for k=1:nf0
formatSpec='%5.2f       %7.5f    %7.5f\n';
fprintf(formatSpec,f0_T(k),E1(k),E2(k))
end
disp(' ')
disp('- :')
disp('..       ')
for k=1:nf0
formatSpec='%5.2f       %7.5f    %7.5f\n';
fprintf(formatSpec,f0_T(k),PF1(k),PF2(k))
end