% ..  .
%   MATLAB. 2023
%Script 4.6
%     
clear all; close all; clc
%  
% 
F=1;
% 
t0=.5/F;
%     
fmin=-2*F; fmax=2*F;
%   
df=.01;
%  
f=fmin:df:fmax;
%     
tmin=-2*t0; tmax=5*t0;
%   
dt=.01;
%  
t=tmin:dt:tmax;
%    
%  
H=rectpuls(f,2*F).*exp(-1i*2*pi*f*t0);
%
subplot(2,2,1)
plot(f,abs(H))
grid
ymin=-.1; ymax=1.1;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('|H(f)|')
title(['   , F_c = ',num2str(F),...
' , t_0 = ',num2str(t0),' '],...
'Units','normalized','Position',[1.155 1.03 0])
%
subplot(2,2,2)
phi=angle(H);
plot(f,phi)
grid
ymin=min(phi)-.3;
ymax=max(phi)+.3;
xlim([fmin fmax])
ylim([ymin ymax])
xlabel('f, ')
ylabel('\phi(f), ')
% 
h=2*F*sinc(2*F*(t-t0));
subplot(2,2,3)
plot(t,h)
grid
ymin=min(h)-.1;
ymax=1.1*2*F;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('h(t), ^{-1}')
line([t0 t0],[0 2*F],'LineStyle','--')
line([tmin tmax],[0 0],'LineStyle','--')
% 
k=1/pi*sinint(2*pi*F*t)+.5;
subplot(2,2,4)
plot(t,k)
grid
ymin=min(k)-.05;
ymax=max(k)+.05;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('k(t)')
line([t0 tmax],[1 1],'LineStyle','--')
line([t0 t0],[1 0],'LineStyle','--')
line([tmin tmax],[0 0],'LineStyle','--')
%  
fprintf('  k(t): %f.\n',max(k))
fprintf('  k(t): %f.\n',min(k))