% ..  .
%   MATLAB. 2023
%Script 5.3
%     
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%     
tmin=-1.1*T;
tmax=1.1*T;
% 
dt=.00001;
%  
t=tmin:dt:tmax;
%  
vf0=[1/T,5/T,10/T];
vw0=2*pi*vf0;
%  
nf=length(vf0);
%  
dr=zeros(1,nf);
dr1=zeros(1,nf);
%    
for k=1:nf
f0=vf0(k);
w0=vw0(k);
% 
a=U0*rectpuls(t,T);
%
u=a.*cos(w0*t);
%  
figure
subplot(3,1,1)
plot(t,u,t,a,'g--')
grid
ymax=1.1*U0;
xlim([tmin tmax])
ylim([-ymax ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , T = ',num2str(T),' ,'...
' f_0 = ',num2str(f0),' ']);   
%    
%    
[rx,lags]=xcorr(u);
tau=lags*dt;
rc=rx*dt;
a=U0^2*T/2*tripuls(tau,2*T,0);
% 
subplot(3,1,2)
plot(tau,rc,tau,a,'g--')
grid
xlim([tmin tmax])
ymax=1.1*U0^2*T/2;
ylim([-ymax ymax])
xlabel('t, ')
ylabel('r(\tau), ')
legend('')
%     
r1=a.*cos(w0*tau);
r2=U0^2*T/2*sin(w0*(T-abs(tau)))/(w0*T).*rectpuls(tau,2*T);
r=r1+r2;
% 
subplot(3,1,3)
plot(tau,r,tau,r1,'r:')
legend('','.')
hold on
plot(tau,a,'g--')
grid
xlim([tmin tmax])
ylim([-ymax ymax])
xlabel('t, ')
ylabel('r(\tau), ')
%   
dr(k)=max(abs(rc-r));
dr1(k)=max(abs(rc-r1));
end
disp('  ')
for k=1:nf
disp('----------------------------------')
fprintf('%i.  : %f :\n',k,vf0(k))
disp('----------------------------------')
fprintf('-  : %e ;\n',dr(k))
fprintf('-  : %e .\n',dr1(k))
end