% ..  .
%   MATLAB. 2023
%Script 5.6
%    
clc; clear all; close all
%  
% 
U1=1; U2=.5;
% ""
a1=.5; a2=1;
%     
tmin=-5/min(a1,a2);
tmax=5/min(a1,a2);
% 
dt=.0001;
%  
t=tmin:dt:tmax;
%    
% 
u1=U1*exp(-a1*t).*(t>=0);
u2=U2*exp(-a2*t).*(t>=0);
%  
subplot(3,1,1)
plot(t,u1,t,u2)
grid
xlim([tmin tmax])
ymin=-.1;
ymax=1.1*max(U1,U2);
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_1(t), u_2(t), ')
legend('u_1(t)','u_2(t)','Location','NorthWest')
title(['  u_1(t)  u_2(t)  U_1 = ',num2str(U1),...
' , U_2 = ',num2str(U2),' , \alpha_1 = ',num2str(a1),...
' ^{-1}, \alpha_2 = ',num2str(a2),' ^{-1}']);   
 
%    
%    
[rx,lags]=xcorr(u1,u2);
tau=lags*dt;
rc=rx*dt;
% 
subplot(3,1,2)
plot(tau,rc)
grid
xlim([tmin tmax])
ymax=1.1*U1*U2/(a1+a2);
ylim([ymin ymax])
xlabel('t, ')
ylabel('r_{12}(\tau), ')
legend('')
%   
r_fct=@(t) U1*U2/(a1+a2)*(exp(a2*t).*(t<0)+exp(-a1*t).*(t>=0));
%   
r=r_fct(tau);
% 
subplot(3,1,3)
plot(tau,r)
grid
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('r_{12}(\tau), ')
legend('')
%   
dr=max(abs(rc-r));
fprintf('  : %e .\n',dr)