% ..  .
%   MATLAB. 2023
%Script 5.7
%    
%    
clear all; close all; clc
%    
%  
R=@(x) sinc(x).^2;
%  
Rl=@(x)10*log10(R(x));
%     
%1.   
fun=@(x) R(x)-.5;
x0=1;
FT(1)=fzero(fun,x0);
g(1)=2*integral(R,0,FT(1));
%2.  
FT(2)=.5;
g(2)=2*integral(R,0,FT(2));
%3.   
FT(3)=1;
g(3)=2*integral(R,0,FT(3));
%4.  0,99 
gamma=.99;
fct=@(x) 2*integral(R,0,x)-gamma;
x0=1;
FT(4)=fzero(fct,x0);
g(4)=gamma;
%5.      35 
dr=-35;
fun = @(x) R(x)-10^(.1*dr);
x0=[17.5 18.5];
FT(5)=fzero(fun,x0);
g(5)=2*integral(R,0,FT(5));
fprintf('  .  \n');
fprintf(' \n');
fprintf('----------------------------------------\n');
fprintf('         FT           gamma \n');
fprintf('----------------------------------------\n');
fprintf('1.   1/2   %f     %f\n',FT(1),g(1));
fprintf('2. . .   %f     %f\n',FT(2),g(2));
fprintf('3.  1-     %f     %f\n',FT(3),g(3));
fprintf('4.  0,99 .  %f    %f\n',FT(4),g(4));
fprintf('5.  . -35    %f    %f\n',FT(5),g(5));
%  
fT=0:.01:1.5;
subplot(2,1,1)
plot(fT,R(fT))
grid
set(gca,'XMinorTick','on')
set(gca,'YMinorTick','on')
xlabel('fT')
ylabel('R^+(f) / R^+_{max}')
ylim([0 1.1])
title('    ');   
% 
hold on
%1.   
dx=.07;
dy=.1;
line([0 FT(1)],[.5 .5],'LineStyle','--','Color','g')
line([FT(1) FT(1)],[.5 0],'LineStyle','--','Color','g')
plot(FT(1),0,'r.')
text(FT(1)-dx,dy,'F_1T')
%2.  
line([0 FT(2)],[1 1],'LineStyle','--','Color','g')
line([FT(2) FT(2)],[1 0],'LineStyle','--','Color','g')
plot(FT(2),0,'r.')
text(FT(2),dy,'F_2T')
%3.   
plot(FT(3),0,'r.')
text(FT(3),dy,'F_3T')
fT=0:.01:20;
subplot(2,1,2)
plot(fT,Rl(fT))
grid
set(gca,'XMinorTick','on')
set(gca,'YMinorTick','on')
xlabel('fT')
ylabel('R^+(f) / R^+_{max}, ')
ymin=-40;
ylim([ymin 0])
hold on
% 
%4.  0,99 
dy=-27;
plot(FT(4),ymin,'r.')
text(FT(4),dy,'F_4T')
%5.      35 
line([0 FT(5)],[dr dr],'LineStyle','--','Color','g')
line([FT(5) FT(5)],[dr ymin],'LineStyle','--','Color','g')
plot(FT(5),ymin,'r.')
text(FT(5),dy,'F_5T')
%   
vf=0:.02:20;
nf=length(vf);
y=zeros(1,nf);
for k=1:nf
f=vf(k);
y(k)=2*integral(R,0,f);
end
figure
subplot(2,1,1)
plot(vf,y)
xlim([0 1.5])
ylim([0 1.1])
grid
set(gca,'XMinorTick','on')
set(gca,'YMinorTick','on')
xlabel('FT')
ylabel('\gamma')
title('      FT');   
% 
hold on
for k=1:3
line([0 FT(k)],[g(k) g(k)],'LineStyle','--','Color','g') 
line([FT(k) FT(k)],[g(k) 0],'LineStyle','--','Color','g') 
plot(FT(k),g(k),'r.')
plot(FT(k),0,'r.')
end
%1.   
dx=.07;
dy=.1;
text(FT(1)-dx,dy,'F_1T')
%2.  
text(FT(2),dy,'F_2T')
%3.   
text(FT(3),dy,'F_3T')
subplot(2,1,2)
plot(vf,y)
ylim([0 1.1])
grid
set(gca,'XMinorTick','on')
set(gca,'YMinorTick','on')
xlabel('FT')
ylabel('\gamma')
% 
hold on
line([0 FT(5)],[g(5) g(5)],'LineStyle','--','Color','g') 
for k=4:5
line([FT(k) FT(k)],[g(k) 0],'LineStyle','--','Color','g') 
plot(FT(k),g(k),'r.')
plot(FT(k),0,'r.')
end
%4.  0,99 
text(FT(4),dy,'F_4T')
%5.      35 
text(FT(5),dy,'F_5T')