% ..  .
%   MATLAB. 2023
%Script 6.2
%     
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%    
tmin=-T;
tmax=T;
% 
dt=.001;
% 
TN=tmax-tmin;
%  
t=tmin:dt:tmax;
%   
gamma=.999;
%   
Tv=.005*T;
%   
%     
R=@(x) cos(pi*x).^2./(1-4*x.^2).^2;
fct=@(x) 16/pi^2*integral(R,0,x)-gamma;
x0=1;
FT=fzero(fct,x0);
% 
F=FT/T;
% 
del_t=1/(2*F);
%  
N=fix(2*F*T)+1;
%   
td=-T/2:del_t:T/2;
%  
fprintf('   :\n');
fprintf('------------------------------------------------\n');
fprintf('-      %f;\n',gamma);
fprintf('-    %f ;\n',F);
fprintf('-   %f \n',del_t);
fprintf('-    %i;\n',N);
%     ( )
%1-e  
%   
%   
u=@(x) U0*cos(pi/T*x).*(abs(x)<=T/2);
subplot(3,1,1)
plot(t,u(t))
grid
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , T = ',num2str(T),' ']);   
ymin=-.2*U0;
ymax=1.2*U0;
ylim([ymin ymax])
%    (-)
ud=u(td);
subplot(3,1,2)
MS=4;
stem(td,ud,'Fill','MarkerEdgeColor','r','MarkerSize',MS)
hold on
plot(t,u(t),':')
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_d(t), ')
title('  u_d(t) (-)'); 
%      
func=@(x) sinc(2*F*x);
%    
d=[td' ud'];
% 
y=pulstran(t,d,func);
%   
subplot(3,1,3)
plot(t,y)
hold on
%   
plot(td,ud,'or','MarkerFaceColor','r','MarkerSize',MS)
grid
%   
for k=1:N
yy=ud(k)*func(t-td(k));
plot(t,yy,':')
end
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)     \gamma = '...
       ,num2str(gamma)]); 
%   
d2=sum((y-u(t)).^2)*dt;
Eu=sum(u(t).^2)*dt;
err=d2/Eu;
fprintf('-    () %f.\n',err);
%     (  )
%2-e  
%   
figure
subplot(3,1,1)
plot(t,u(t))
grid
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , T = ',num2str(T),' ']);   
ylim([ymin ymax])
%    ( )
%    
func=@(x) rectpuls(x,Tv);
%    
d=[td' ud'];
% 
ud=pulstran(t,d,func);
subplot(3,1,2)
plot(t,ud)
hold on
plot(t,u(t),':')
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_d(t), ')
title(['  u_d(t) '...
       '(   T_v = ',num2str(Tv),' )']);
%     6- 
%   F    fs
fs=1/dt;
[b,a]=butter(6,F/(fs/2));
% 
y=filtfilt(b,a,ud)/(2*F)/Tv;
subplot(3,1,3)
plot(t,y)
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)     \gamma = '...
       ,num2str(gamma)]); 
%   
d2=sum((y-u(t)).^2)*dt;
Eu=sum(u(t).^2)*dt;
err=d2/Eu;
fprintf('-    () %f.\n',err);