% ..  .
%   MATLAB. 2023
%Script 6.4
%    
clear all; close all; clc
%  
% 
U0=1;
% ""
a=1;
%  
T=5/a;
%    
tmin=-T/2;
tmax=T/2;
% 
dt=.001;
%  
t=tmin:dt:tmax;
%   
gamma=.99999;
%   
Tv=.008*T;
%   
%     
fct=@(x) erf(sqrt(2)*pi/a*x)-gamma;
F0=.1;
% 
F=fzero(fct,F0);
% 
del_t=1/(2*F);
%  
N=fix(2*F*T)+1;
%   
td=tmin:del_t:tmax;
%  
fprintf('   :\n');
fprintf('-----------------------------------------------\n');
fprintf('-      %f;\n',erf(a*T/sqrt(2)));
fprintf('-      %f;\n',gamma);
fprintf('-    %f ;\n',F);
fprintf('-   %f \n',del_t);
fprintf('-    %i;\n',N);
%     ( )
%1-e  
%   
%   
u=@(x) U0*exp(-(a*x).^2);
subplot(3,1,1)
plot(t,u(t))
grid
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , \alpha = ',num2str(a),' ^{-1}, T = ',num2str(T),' ']);   
ymin=-.2*U0;
ymax=1.2*U0;
ylim([ymin ymax])
%    (-)
ud=u(td);
subplot(3,1,2)
MS=4;
stem(td,ud,'Fill','MarkerEdgeColor','r','MarkerSize',MS)
hold on
plot(t,u(t),':')
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_d(t), ')
title('  u_d(t) (-)');  
%      
func=@(x) sinc(2*F*x);
%    
d=[td' ud'];
% 
y=pulstran(t,d,func);
%   
subplot(3,1,3)
plot(t,y)
hold on
%   
plot(td,ud,'or','MarkerFaceColor','r','MarkerSize',MS)
grid
%   
for k=1:N
yy=ud(k)*func(t-td(k));
plot(t,yy,':')
end
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)     \gamma = '...
       ,num2str(gamma)]);
%   
d2=sum((y-u(t)).^2)*dt;
Eu=sum(u(t).^2)*dt;
err=d2/Eu;
fprintf('-    () %f.\n',err);
%     (  )
%2-e  
%   
figure
subplot(3,1,1)
plot(t,u(t))
grid
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)  U_0 = ',num2str(U0),...
' , \alpha = ',num2str(a),' ^{-1}, T = ',num2str(T),' ']);   
ylim([ymin ymax])
%    ( )
%    
func=@(x) rectpuls(x,Tv);
%    
d=[td' ud'];
% 
ud=pulstran(t,d,func);
subplot(3,1,2)
plot(t,ud)
hold on
plot(t,u(t),':')
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_d(t), ')
title(['  u_d(t) '...
       '(   T_v = ',num2str(Tv),' )']);
%     6- 
%   F    fs
fs=1/dt;
[b,a]=butter(4,F/(fs/2));
% 
y=filtfilt(b,a,ud)/(2*F)/Tv;
subplot(3,1,3)
plot(t,y)
grid
ymax=max(y)+.1*U0;
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['  u(t)     \gamma = '...
       ,num2str(gamma)]); 
%   
d2=sum((y-u(t)).^2)*dt;
Eu=sum(u(t).^2)*dt;
err=d2/Eu;
fprintf('-    () %f.\n',err);