% ..  .
%   MATLAB. 2023
%Script 7.1
%       
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%  
N=4;
%  
tau0=T/N;
%  
f0=2/tau0;
%   
nsamp=1001;
%   
dt=tau0/nsamp;
%  
t=0:dt:(nsamp*N-1)*dt;
% 
phi=2*pi/N*((1:N)-(N+1)/2).^2; 
% 
d=exp(1i*phi);
%1- 
%   
dtau=.5*tau0:tau0:N*tau0;
dq=[dtau;d]';
v=U0*pulstran(t,dq,'rectpuls',tau0);
%  
u=real(v.*exp(1i*2*pi*f0*t));
%  
subplot(4,1,1)
plot(t,u)
grid
xmax=ceil(max(t));
xlim([0 xmax])
ymin=-1.1*U0;
ymax=1.1*U0;
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
title(['        U_0 = ',...
        num2str(U0),' , T = ',num2str(T),' , N = ',num2str(N),]);   
%   
dp=[dtau;phi]';
phase=pulstran(t,dp,'rectpuls',tau0);
%  
subplot(4,1,2)
plot(t,phase)
grid
xlim([0 xmax])
ymin=-.5;
ymax=ceil(max(phase))+.5;
ylim([ymin ymax])
xlabel('t, ')
ylabel('\phi(t), ')
%  
a=abs(v);
%   
dc=[dtau;cos(phi)]';
uc=a.*pulstran(t,dc,'rectpuls',tau0);
%   
subplot(4,1,3)
plot(t,uc)
grid
xlim([0 xmax])
ymin=-1.1*U0;
ymax=1.1*U0;
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_c(t), ')
%   
ds=[dtau;sin(phi)]';
us=a.*pulstran(t,ds,'rectpuls',tau0);
%   
subplot(4,1,4)
plot(t,us)
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u_s(t), ')
%   
dh=150;
hp=get(gcf,'Position');
h1=hp(1); h2=hp(2)-dh; h3=hp(3); h4=hp(4)+dh;
set(gcf,'Position',[h1 h2 h3 h4])
%2- 
%   
fmax=2/tau0;
%   
df=.001;
%  
f=-fmax:df:fmax;
%    
s=0;
for k=1:N 
s=s+d(k)*exp(-1i*2*pi*(k-1)*f*tau0);  
end
V=U0*tau0*sinc(f*tau0).*exp(-1i*pi*f*tau0).*s;
figure
%     
subplot(2,1,1)
plot(f,abs(V))
grid
xlabel('f, ')
ylabel('|V(f)|, /')
str1='         '; 
str2=[' U_0 = ',num2str(U0),' B, T = ',num2str(T),...
    ' , N = ',num2str(N)];
title({str1;str2}) 
%     
subplot(2,1,2)
plot(f,unwrap(angle(V)))
grid
xlabel('f, ')
ylabel('\phi(f), ')
%  
disp(' :') 
disp('--------------') 
for k=1:N
fprintf('%i  %6.4f*pi\n',k,phi(k)/pi); 
end