% ..  .
%   MATLAB. 2023
%Script 7.12
% - 
%     
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
% 
f0=3/T;
% 
phi=[0 pi pi/2 pi 0 3*pi/2 0];
%  
N=length(phi);
%  
tau=.2;
%     
tmin=0; tmax=N*T;
%   
dt=.001/f0;
%  
t=tmin:dt:tmax;
%     
fun_y=@(t) (1-exp(-t/tau)).*heaviside(t)...
          -(1-exp(-(t-T)/tau)).*heaviside(t-T);
%      
d_u=[.5*T:T:N;exp(1i*phi)]';
% 
v=U0*pulstran(t,d_u,'rectpuls',T);
% 
z=v.*exp(1i*2*pi*f0*t);
% 
u=real(z);
%      
d_y=[0:T:N-1;exp(1i*phi)]';
% 
v_y=U0*pulstran(t,d_y,fun_y);
% 
z_y=v_y.*exp(1i*2*pi*f0*t);
% 
y=real(z_y);
ymin=-1.1*U0; ymax=1.3*U0;
%      
subplot(3,1,1)
plot(t,u,t,abs(v),'r--')
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('u(t), ')
str=['    U_0 = ',num2str(U0),' , T = ',num2str(T),...
    ' , N = ',num2str(N),', f_0 = ',num2str(f0),' '];
title(str)
%      
subplot(3,1,2)
plot(t,y,t,abs(v_y),'r--')
grid
ylim([ymin ymax])
xlabel('t, ')
ylabel('y(t), ')
str=['       \tau_c = ',...
    num2str(tau),' '];
title(str)
%         
subplot(3,1,3)
phase=-angle(v);
phase_y=-angle(v_y);
plot(t,phase_y,t,phase,'--')
grid
xlabel('t, ')
ylabel('\phi(t), ')
title('      ')
legend('','')
%   
dh=100;
hp=get(gcf,'Position');
h1=hp(1); h2=hp(2)-dh; h3=hp(3); h4=hp(4)+dh;
set(gcf,'Position',[h1 h2 h3 h4])
%  
disp(' :') 
disp('-------------') 
for k=1:N
fprintf('%i  %3.1f*pi\n',k,phi(k)/pi); 
end