% ..  .
%   MATLAB. 2023
%Script 7.5
%  sin(x)/x), 
%     
%  ,   ,   
%
clear all; close all; clc
%  
% 
U0=1;
% ""
alpha=1;
%1- 
%     
tmin=-3.5*pi/alpha; tmax=3.5*pi/alpha;
dt=.01;
t=tmin:dt:tmax;
u=U0*sinc(alpha*t/pi);
ug=U0*.5*alpha*t.*(sinc(.5*alpha*t/pi)).^2;
subplot(2,2,1)
plot(t,u)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('u(t), ')
str=[' u(t)  U_0 =',num2str(U0),...
    ' , \alpha = ',num2str(alpha),' ^{-1}'];
title(str)
subplot(2,2,3)
plot(t,ug)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('u_g(t), ')
title(' u_g(t)')
%       
fmin=-.25*alpha; fmax=.25*alpha;
df=.0001;
f=fmin:df:fmax;
w=2*pi*f;
U=pi*U0/alpha*rectpuls(w,2*alpha);
Ug=U.*sign(f);
subplot(2,2,2)
plot(f,U)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('U(f), /')
title('  u(t)')
subplot(2,2,4)
plot(f,Ug)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('jU_g(f), /')
title('  u_g(t)')
%2- 
%   
a=U0*abs(sinc(.5*alpha*t/pi));
figure;
subplot(2,2,1)
plot(t,a,t,u,':')
grid
xlim([tmin tmax])
legend('a(t)','u(t)','Location','SouthWest')
xlabel('t, ')
ylabel('a(t), ')
title('  z(t)')
%    
fun_psi=@(x,k)(alpha*x/2.+k*sign(x)*pi).*(abs(x)>=k*2*pi/alpha & abs(x)<=(k+1)*2*pi/alpha);
psi=0;
for k=0:fix(tmax*alpha/(2*pi))
psi=psi+fun_psi(t,k);    
end
subplot(2,2,3)
plot(t,psi)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('\psi(t), ')
title('   z(t)')
%   
fmin=-.04*alpha; fmax=.2*alpha;
df=.001;
Rz=(2*pi*U0/alpha)^2*rectpuls(w-alpha/2,alpha);
subplot(2,2,2)
plot(f,Rz)
hold on
% f0
f0=alpha/(4*pi);
plot(f0,0,'.r')
text(f0,.1*max(Rz),'f_0')
grid
xlim([fmin fmax])
ylim([0 1.1*max(Rz)])
xlabel('f, ')
ylabel('R_z(f), /')
title('  z(t)')
%    
freq=ones(1,length(t))*alpha/(4*pi);
subplot(2,2,4)
plot(freq,t)
grid
xlim([fmin fmax])
ylim([tmin tmax])
xlabel('f(t), ')
ylabel('t, ')
title('   z(t)')