% ..  .
%   MATLAB. 2023
%Script 7.7
%      ,
%     
%  ,   ,   
%
clear all; close all; clc
%  
%  
U1=1; U2=2;
%  
f1=.5; f2=1;
%   
w1=2*pi*f1; w2=2*pi*f2;
%1- 
%     
tmin=0; tmax=1/min(f1,f2);
dt=.001;
t=tmin:dt:tmax;
u=U1*cos(w1*t)+U2*cos(w2*t);
ug=U1*sin(w1*t)+U2*sin(w2*t);
Um=U1+U2;
subplot(2,2,1)
plot(t,u)
grid
xlim([tmin tmax])
ylim([-1.1*Um 1.1*Um])
xlabel('t, ')
ylabel('u(t), ')
str1=[' u(t)  U_1 = ',num2str(U1),...
    ' , f_1 = ',num2str(f1),' ,'];
str2=['U_2 = ',num2str(U2),' , f_2 = ',num2str(f2),' '];
title({str1;str2})
subplot(2,2,3)
plot(t,ug)
grid
xlim([tmin tmax])
ylim([-1.1*Um 1.1*Um])
xlabel('t, ')
ylabel('u_g(t), ')
title(' u_g(t)')
%       
fmin=-(f1+f2); fmax=(f1+f2);
subplot(2,2,2)
MS=4;
xf=[-f1 f1 -f2 f2];
yf=[U1/2 U1/2 U2/2 U2/2];
stem(xf,yf,'Fill','MarkerEdgeColor','r','MarkerSize',MS)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('U(f), /')
title('  u(t)')
subplot(2,2,4)
xf=[-f1 f1 -f2 f2];
yf=[-U1/2 U1/2 -U2/2 U2/2];
stem(xf,yf,'Fill','MarkerEdgeColor','r','MarkerSize',MS)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('jU_g(f), /')
title('  u_g(t)')
%2- 
%   
dw=w2-w1;
a=sqrt(U1^2+U2^2+2*U1*U2*cos(dw*t));
figure;
subplot(2,2,1)
plot(t,a,t,u,':')
grid
xlim([tmin tmax])
legend('a(t)','u(t)','Location','South')
xlabel('t, ')
ylabel('a(t), ')
title('  z(t)')
%    
psi=unwrap(atan2(ug,u));
subplot(2,2,3)
plot(t,psi)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('\psi(t), ')
title('   z(t)')
%   
fmin=0; fmax=2*max(f1,f2);
df=.001;
f=fmin:df:fmax;
subplot(2,2,2)
xf=[f1 f2];
yf=[U1^2 U2^2];
stem(xf,yf,'Fill','MarkerEdgeColor','r','MarkerSize',MS)
% w0
w0=(U1^2*w1+U2^2*w2)/(U1^2+U2^2);
f0=w0/(2*pi);
hold on
plot(f0,0,'r.')
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('R_z(f), /')
title('  z(t)')
%    
w=w0+U1*U2*(U1^2-U2^2)*dw*cos(dw*t)./((U1^2+U2^2).*a.^2);
freq=w/(2*pi);
subplot(2,2,4)
plot(freq,t)
line([f1 f1],[tmin tmax],'LineStyle','--')
line([f2 f2],[tmin tmax],'LineStyle','--')
line([f0 f0],[tmin tmax],'LineStyle','--','Color','r')
grid
xlim([fmin fmax])
ylim([tmin tmax])
xlabel('f(t), ')
ylabel('t, ')
title('   z(t)')