% ..  .
%   MATLAB. 2023
%Script 7.9
% ,
%     
%  ,   ,   
%
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
% 
f0=2/T;
%1- 
%     
tmin=-.6*T; tmax=.6*T;
dt=.001;
t=tmin:dt:tmax;
u=U0*tripuls(t,T).*cos(2*pi*f0*t);
ug=imag(hilbert(u));
subplot(2,2,1)
plot(t,u)
grid
xlim([tmin tmax])
ylim([-1.5*U0 1.5*U0])
xlabel('t, ')
ylabel('u(t), ')
str=[' u(t), U_0 =',num2str(U0),...
    ' , T = ',num2str(T),' , f_0 = ',num2str(f0),' '];
title(str)
subplot(2,2,3)
plot(t,ug)
grid
xlim([tmin tmax])
ylim([-1.5*U0 1.5*U0])
xlabel('t, ')
ylabel('u_g(t), ')
title(' u_g(t)')
%       
fmin=-f0-4/T; fmax=f0+4/T;
df=.001;
f=fmin:df:fmax;
fun_U=@(f) U0*T/4*(sinc((f-f0)*T/2).^2+sinc((f+f0)*T/2).^2);
U=fun_U(f);
Ug=U.*sign(f);
subplot(2,2,2)
line([fmin fmax],[0 0])
hold on
plot(f,U,-f0,0,'.r',f0,0,'.r')
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('U(f), /')
title('  u(t)')
subplot(2,2,4)
line([fmin fmax],[0 0])
hold on
plot(f,Ug,-f0,0,'.r',f0,0,'.r')
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('jU_g(f), /')
title('  u_g(t)')
%2- 
%   
a=sqrt(u.^2+ug.^2);
figure;
subplot(2,2,1)
plot(t,a,t,u,':')
grid
xlim([tmin tmax])
ylim([-1.5*U0 3*U0])
legend('a(t)','u(t)','Location','North')
xlabel('t, ')
ylabel('a(t), ')
title('  z(t)')
%    
psi=unwrap(atan2(ug,u));
subplot(2,2,3)
plot(t,psi)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('\psi(t), ')
title('   z(t)')
%   
fmin=0; fmax=f0+4/T;
df=.001;
f=fmin:df:fmax;
fun_R=@(f) 4*fun_U(f).^2.*(f>=0);
Rz=fun_R(f);
subplot(2,2,2)
plot(f,Rz,f0,0,'.r')
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('R_z(f), /')
title('  z(t)')
%5.   
omega=diff(psi)/dt; omega(end+1)=omega(end);
freq=omega/(2*pi);
subplot(2,2,4)
plot(freq,t)
hold on
line([f0 f0],[tmin tmax],'LineStyle','--','Color','r')
grid
xlim([fmin fmax])
ylim([tmin tmax])
xlabel('f(t), ')
ylabel('t, ')
title('   z(t)')